<template>
  <div>
    <!--引用表格-->
    <BasicTable @register="registerTable" :rowSelection="rowSelection">
      <!-- 行业分类 -->
      <template #form-suspect="{ model, field }">
        <a-select
          v-model:value="model[field]"
          placeholder="请选择行业分类"
          :fieldNames="{ label: 'text', value: 'value' }"
          :options="isSuspectOptions"
          @change="changeSuspect"
        ></a-select>
      </template>
      <template #form-category="{ model, field }">
        <a-tree-select
          v-model:value="model[field]"
          show-search
          placeholder="请选择二级"
          allow-clear
          tree-default-expand-all
          :field-names="{ label: 'name', value: 'id', children: 'children' }"
          :tree-data="treeData"
          tree-node-filter-prop="label"
        >
          <template #suffixIcon>
            <SmileOutlined />
          </template>
        </a-tree-select>
      </template>
      <!--插槽:table标题-->
      <template #tableTitle>
        <a-button type="primary" @click="handle('ckglxx')" v-auth="'hqgl-ckglxx'">查看管理记录</a-button>
        <a-button type="primary" @click="handle('tjgljl')" v-auth="'hqgl-tjgljl'">添加管理记录</a-button>
        <a-button type="primary" @click="handle('fjxz')" v-auth="'fjgl-fjxz'">附件下载</a-button>
        <a-button type="primary" @click="onExportXls" v-auth="'hqgl-dc'">导出</a-button>
      </template>
      <!--操作栏-->
    </BasicTable>
  </div>
</template>

<script lang="ts" name="dkgl-investigate-Acceptance" setup>
  import { BasicTable } from '/@/components/Table';
  import { useListPage } from '/@/hooks/system/useListPage';
  import { columns, searchFormSchema, useSuspectsData, useCategoryData } from './data';
  import { hqglList, getExportUrl } from './api';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { useRouter } from 'vue-router';
  import { downloadFile } from '/@/api/common/api';

  const { createMessage } = useMessage();
  let router = useRouter();
  //注册table数据
  const { tableContext, onExportXls } = useListPage({
    tableProps: {
      title: '后期管理-后期管理',
      api: hqglList,
      columns,
      canResize: false,
      //定义rowSelection的类型，默认是checkbox多选，可以设置成radio单选
      rowKey: 'wrdkid',
      clickToRowSelect: true,
      showActionColumn: false,
      rowSelection: { type: 'checkbox' },
      formConfig: {
        labelWidth: 120,
        schemas: searchFormSchema,
        autoSubmitOnEnter: true,
        showAdvancedButton: false,
      },
      actionColumn: {
        width: 120,
      },
    },
    exportConfig: {
      name: '后期管理',
      url: getExportUrl,
    },
  });
  const isSuspectOptions = useSuspectsData().data; // 行业分类
  const useCategory = useCategoryData();
  const treeData = useCategory.data; // 行业类别-数据
  const changeSuspect = useCategory.changeIsSuspect; // 行业类别-方法
  const [registerTable, {}, { rowSelection, selectedRowKeys, selectedRows }] = tableContext;

  function handle(v) {
    if (v == 'fjxz') {
      if (selectedRowKeys.value.length == 0) {
        createMessage.info('请选择需要处理的内容，至少选中一条');
        return;
      }
      downloadFile('/qdgl/hqglBatchDownLoad', `地块管理-后期管理附件.zip`, {wrdkids:selectedRowKeys.value.join(',') });
      return
    }
    if (selectedRowKeys.value.length == 0 || selectedRowKeys.value.length > 1) {
      createMessage.info('请选择需要处理的内容，每次只能选中一条');
      return;
    }
    if (v == 'ckglxx') {
      // 跳查看管理列表
      router.push(
        `/dkgl/hqgl/ViewList?wrdkid=${selectedRowKeys.value[0]}&wrdkmc=${selectedRows.value[0].wrdkmc}&wrdkbm=${selectedRows.value[0].wrdkbm}`
      );
    } else if (v == 'tjgljl') {
      router.push(`/dkgl/hqgl/add?wrdkid=${selectedRowKeys.value[0]}`);
    }
  }
</script>
<style scoped></style>
